/*

This source file is part of the Solar Visitor program, (c) 2007
Graeme Sheppard. Released under the GPLv2.

*/


#include "Menus.h"

static const char *szMenu =
  "0:_Animation:_Hud:_Lights\n"
  "Animation:Time Forward:Time Backward:Time Stop:Time Epoch\n"
  "Hud:Ogre FPS:FPS:Reset View:Screenshot:Change Screen Mode\n"
  "Lights:Toggle Mobile Light:New Fixed Light:Remove User Lights\n";

using namespace Ogre;


String Menus::nextText()
{
  String sReturn;
  char cLetter;
  
  if (*szMainPointer == '\0')
  {
    cEndCharacter = '\0';
    return "";
  }
  
  sReturn = "";
  
  for (;;)
  {
    cLetter = *szMainPointer;
    if (cLetter == '\0')
      break;
    szMainPointer++;
    if (cLetter == '\n' || cLetter == ':')
      break;
    sReturn = sReturn + cLetter;
  }

  cEndCharacter = cLetter;
  return sReturn;
}


String Menus::getMenuItem (const char *szTitle, int iIndex)
{
  String sText;
  int iCount;

  if ((strcmp (szTitle, "") == 0) || iIndex < 0)
    return "";

  szMainPointer = szMenu;

  for (;;)
  {
    sText = nextText();
    if (sText == "")
      return "";
    if (sText == szTitle)
      break;
    for (;;)
    {
      if (cEndCharacter == '\0')
        return "";
      if (cEndCharacter == '\n')
        break;
      nextText();
    }
  }

  if (cEndCharacter != ':')
    return "";

  for (iCount = 0; iCount < iIndex; iCount++)
  {
    nextText();
    if (cEndCharacter != ':')
      return "";
  }
  
  return nextText();
}

