/*

This source file is part of the Solar Visitor program, (c) 2007
Graeme Sheppard. Released under the GPLv2.

*/


#include "Ogre.h"

#include "Types.h"


using namespace Ogre;

class Planet
{
  public:

  String sName, sMesh, sOrbiting;
  Real rX, rY, rZ;
  Real rOrbitRadius; // yes, cheap - not "ellipical"
  Degree rInitialAngle;
  Quaternion oSlant, oOrbitSlant, oOrientationNow;
  Real rYear; // can be negative
  Real rSpin; // can be negative
};


class SolarSystem
{
  public:

  SolarSystem (SceneManager*);
  void addPlanet (const char *szName, const char *szMesh, Real rScale,
    const char *szFacing, Real rOrbitRadius, Real rYear, Real rSpin,
    Real rXorb, Real rYorb, Real rZorb, Real rXort, Real rYort, Real rZort);
  void addPlanets();
  void addBody (Planet *oPlanet, Real rScale);
  Planet* findPlanet (const char *szName);
  void updatePosition (Planet *oPlanet, sv64 iTime);

  SceneManager *oSceneManager;
  std::vector<Planet*> oPlanets; // list of planets
};
